// exdump - 0.1 - By PolarRoot [pi9@hotmail.com]
//	Thanks to:	Solar Designer - i ripped some of your code!

#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>

// Structure Definitions
struct HEADER {
	struct ip ip;
	struct tcphdr tcp;
	char space[60-sizeof(struct ip)];
};

// Function Declarations
void main (int argc, char **argv);
void process_packet (struct HEADER packet, int size);
void packet_type (struct tcphdr tcp, char type[16]);
void tcp_flags (struct tcphdr tcp, char flags[8]);
int ignore_packet (struct HEADER packet);
int process_command (int argc, char **argv);
void watch_mnemonic (char watch[16]);

// Global Definitions
int raw;
int ret;
struct HEADER packet;
int size;
static struct hostent *host;
static char LOCALHOST_NAME [256];

// Option Definitions
int OPT_WATCH_ALL=0;
int OPT_NO_DATA=0;
int OPT_WATCH_LOCAL=0;
int OPT_WATCH_OUTSIDE=0;
int OPT_WATCH_PORT=0;
int OPT_VERBOSE_MODE=0;
int OPT_OUTPUT_FILE=0;
char OUTPUT_FILE[1024]="";
FILE *hOUTPUT_FILE;
unsigned int port;

// process_command() Function
int process_command (int argc, char **argv) {
	int c;

	while (0==0) {
		c=getopt(argc, argv, "adf:hop:v?");
		if (c==EOF) break;
		switch (c) {
			case 'a':
				OPT_WATCH_ALL=1;
				break;
			case 'd':
				OPT_NO_DATA=1;
				break;
			case 'f':
				OPT_OUTPUT_FILE=1;
				strcpy(OUTPUT_FILE, optarg);
				break;
			case 'h' | '?':
				return 1;
				break;
			case 'l':
				OPT_WATCH_LOCAL=1;
				break;
			case 'o':
				OPT_WATCH_OUTSIDE=1;
				break;
			case 'p':
				OPT_WATCH_PORT=1;
				port=atoi(optarg);
				break;
			case 'v':
				OPT_VERBOSE_MODE=1;
				break;
			default:
				return 1;
				break;
		}
	}
	return 0;
}

// watch_mnemonic() Function
void watch_mnemonic (char watch[16]) {
	if (OPT_WATCH_ALL==1)     { strcpy(watch,"All Packets"); return; }
	if (OPT_WATCH_LOCAL==1)   { strcpy(watch,"Local Packets"); return; }
	if (OPT_WATCH_OUTSIDE==1) { strcpy(watch,"Outside Packets"); return; }
	if (OPT_WATCH_PORT==1)    { strcpy(watch,"Packets on Port"); return; }
	return;
}

// main() Function
void main (int argc, char **argv) {
	char watch[16];
	printf("exdump - Version 0.1 - By PolarRoot [pi9@hotmail.com]\n");
	if (process_command(argc, argv)) {
		printf("Usage:\t%s <options>\n", argv[0]);
		printf("Options:\n");
		printf("\t-a           - show all packets (default)\n");
		printf("\t-d           - do not show data in packet\n");
		printf("\t-f <file>    - send output to <file> file\n");
		printf("\t-h or -?     - show on-screen help (this screen)\n");
//		printf("\t-l           - show only packets for this computer\n");
//		printf("\t-o           - show only packets for other computers\n");
		printf("\t-p <port>    - show only packets for <port> port\n");
		printf("\t-v           - verbose mode (show internals of every packet)\n");
		exit (0);
	}

	// Open OUTPUT_FILE
	if (OPT_OUTPUT_FILE==1) {
		printf("Output Will Be Directed To The File: %s\n", OUTPUT_FILE);
		hOUTPUT_FILE=fopen(OUTPUT_FILE, "a");
		fprintf(hOUTPUT_FILE, "exdump - Version 0.1 - By PolarRoot [pi9@hotmail.com]\n");
		fprintf(hOUTPUT_FILE, "Output Will Be Directed To The File: %s\n", OUTPUT_FILE);
	}
	else {
		hOUTPUT_FILE=stdout;
	}

	ret = gethostname(LOCALHOST_NAME, sizeof(LOCALHOST_NAME));
	host = gethostbyname(LOCALHOST_NAME);
	fprintf(hOUTPUT_FILE, "Watching On: %s [%s]\n", LOCALHOST_NAME, inet_ntoa(*(long *)(host->h_addr)));

	if (OPT_WATCH_LOCAL==0 & OPT_WATCH_OUTSIDE==0 & OPT_WATCH_PORT==0)
		OPT_WATCH_ALL=1;
	watch_mnemonic(watch);
	fprintf(hOUTPUT_FILE, "Watching: %s\n", watch);
	if (OPT_WATCH_PORT==1) fprintf(hOUTPUT_FILE, "Port: %d\n", port);
	if (OPT_VERBOSE_MODE==1) fprintf(hOUTPUT_FILE, "Verbose Mode Enabled\n");
	if (OPT_NO_DATA==1) fprintf(hOUTPUT_FILE, "Data Will Not Be Displayed\n");

	fprintf(hOUTPUT_FILE, "\n\n");

	raw=socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
	if (raw<1) {
		perror("exdump: RAW SOCKETS");
		exit (0);
	}
	while (0==0) {
		size=read(raw, &packet, sizeof(packet));
		if (size>=sizeof(packet.ip))
			process_packet(packet, size);
	}
	close (raw);
	fclose (hOUTPUT_FILE);
	exit (0);
}

// process_packet() Function
void process_packet (struct HEADER packet, int size) {
	char flags[8];
	char type[16];
	struct protoent prot;
	struct servent ss;
	struct servent sd;

	if (ignore_packet(packet)) return;

	tcp_flags(packet.tcp, flags);
	packet_type(packet.tcp, type);
	prot=*getprotobynumber(packet.ip.ip_p);
	if (ntohs(packet.tcp.source)<=1024) ss=*getservbyport(packet.tcp.source, prot.p_name);
	if (ntohs(packet.tcp.dest)<=1024)   sd=*getservbyport(packet.tcp.dest, prot.p_name);

	if (OPT_VERBOSE_MODE!=1) {
		fprintf(hOUTPUT_FILE, "TCP: From: %s (%5d)   To: %s (%5d)   Size: %d  [%s]\n", 
			inet_ntoa(packet.ip.ip_src), ntohs(packet.tcp.source), 
			inet_ntoa(packet.ip.ip_dst), ntohs(packet.tcp.dest), 
			size, type);
		fflush(hOUTPUT_FILE);
	}
	else {
		fprintf(hOUTPUT_FILE, "Packet Received [Size: %i]\n", size);
		fprintf(hOUTPUT_FILE, "IP Header:\n");
		fprintf(hOUTPUT_FILE, "\tHeader Length: %d\n", packet.ip.ip_hl);
		fprintf(hOUTPUT_FILE, "\tVersion: %d\n", packet.ip.ip_v);
		fprintf(hOUTPUT_FILE, "\tType of Service: %d\n", packet.ip.ip_tos);
		fprintf(hOUTPUT_FILE, "\tTotal Length: %d\n", packet.ip.ip_len);
		fprintf(hOUTPUT_FILE, "\tIdentification: %d\n", packet.ip.ip_id);
		fprintf(hOUTPUT_FILE, "\tFragment Offset Field: %d\n", packet.ip.ip_off);
		fprintf(hOUTPUT_FILE, "\tTime to Live: %d\n", packet.ip.ip_ttl);
		fprintf(hOUTPUT_FILE, "\tProtocol: %d (%s)\n", packet.ip.ip_p, prot.p_name);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.ip.ip_sum);
		fprintf(hOUTPUT_FILE, "\tSource Address: %s\n", inet_ntoa(packet.ip.ip_src));
		fprintf(hOUTPUT_FILE, "\tDestination Address: %s\n", inet_ntoa(packet.ip.ip_dst));
		fprintf(hOUTPUT_FILE, "\n");
		fprintf(hOUTPUT_FILE, "TCP Header:\n");
		fprintf(hOUTPUT_FILE, "\tSource Port: %d (%s)\n", ntohs(packet.tcp.source), ss.s_name);
		fprintf(hOUTPUT_FILE, "\tDestination Port: %d (%s)\n", ntohs(packet.tcp.dest), sd.s_name);
		fprintf(hOUTPUT_FILE, "\tSequence Number: %d\n", packet.tcp.seq);
		fprintf(hOUTPUT_FILE, "\tAcknowledgement Number: %d\n", packet.tcp.ack_seq);
		fprintf(hOUTPUT_FILE, "\tTCP Flags: %s\n", flags);
		fprintf(hOUTPUT_FILE, "\tWindow: %d\n", packet.tcp.window);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.tcp.check);
		fprintf(hOUTPUT_FILE, "\tUrgent: %d\n", packet.tcp.urg_ptr);
		if (OPT_NO_DATA==0) {
			fprintf(hOUTPUT_FILE, "\nData:\n");
			fprintf(hOUTPUT_FILE, packet.space);
			fprintf(hOUTPUT_FILE, "\n");
		}
		fprintf(hOUTPUT_FILE, "\n\n");
		fflush(hOUTPUT_FILE);
	}
}

// packet_type() Function
void packet_type (struct tcphdr tcp, char type[16]) {
	// ACK is Least Important, so It Can Be Overwritten
	if (tcp.ack) strcpy(type, "    ACK");
	// All the Rest of the TCP Flags...
	if (tcp.fin) strcpy(type, "  CLOSE");
	if (tcp.syn) strcpy(type, "CONNECT");
	if (tcp.rst) strcpy(type, "  RESET");
	if (tcp.psh) strcpy(type, "   PUSH");
	if (tcp.urg) strcpy(type, " URGENT");
}

// tcp_flags() Function
void tcp_flags (struct tcphdr tcp, char flags[8]) {
	int i;
	for (i=0; i<=8; i++)
		flags[i]='\0';
	if (tcp.fin) strcat(flags, "F");
	if (tcp.syn) strcat(flags, "S");
	if (tcp.rst) strcat(flags, "R");
	if (tcp.psh) strcat(flags, "P");
	if (tcp.ack) strcat(flags, "A");
	if (tcp.urg) strcat(flags, "U");
}

// ignore_packet() Function
int ignore_packet (struct HEADER packet) {
	if (OPT_WATCH_ALL==1) return 0;
// DEBUG
//	if (OPT_WATCH_LOCAL==1 & inet_ntoa(packet.ip.ip_dst)=="127.0.0.1" | inet_ntoa(packet.ip.ip_dst)=="localhost" | inet_ntoa(packet.ip.ip_dst)==LOCALHOST_NAME | inet_ntoa(packet.ip.ip_dst)==inet_ntoa(*(long *)(host->h_addr))) return 0;
//	if (OPT_WATCH_OUTSIDE==1 & inet_ntoa(packet.ip.ip_dst)!="127.0.0.1") return 0;
	if (OPT_WATCH_PORT==1 & ntohs(packet.tcp.dest)==port) return 0;
	return 1;
}

